// Written by Jason Heddings: http://mapit.mozdev.org/
// License: http://creativecommons.org/licenses/by-nc-sa/2.0/

var gMapItAddress = null;

////////////////////////////////////////////////////////////////////////////////
// Attempt to read address from selected text.

function mapItSelectedText() {
  var addr = window._content.__proto__.getSelection.call(window._content).toString();
  gMapItAddress = new MapItAddress(addr);
  //var address = new MapItAddress(gContextMenu.searchSelected());
  if (gMapItAddress.valid && (! gMapItAddress.settings.promptAlways)) {
    // submit the address to the selected map engine
    mapItAddress(gMapItAddress);
  } else {
    // display the dialog to correct the address...
    window.open("chrome://mapit/content/mapitDialog.xul", "_blank", "chrome,resizable");
  }
}

////////////////////////////////////////////////////////////////////////////////
// Map a specific address.

function mapItAddress(address) {
  if (! address.valid) {
    return;
  }

  switch (address.settings.mapper) {
    case "mapquest": mapitMapQuest(address); break;
    case "mapsdotcom": mapitMapsDotCom(address); break;

    default: break;
  }
}

////////////////////////////////////////////////////////////////////////////////
// Called when dialog popup is displayed.

function showMapItPopup() {
}

////////////////////////////////////////////////////////////////////////////////
// Called when dialog popup is hidden.

function hideMapItPopup() {
}

////////////////////////////////////////////////////////////////////////////////
// Change full state name to abbreviated one.
// TODO :jah: this should not be case sensitive,
//            and variants of names should be considered

function mapitAbbreviateState(state) {
  switch (state) {
    case "Alabama":        return "AL";
    case "Alaska":         return "AK";
    case "Arizona":        return "AZ";
    case "Arkansas":       return "AR";
    case "California":     return "CA";
    case "Colorado":       return "CO";
    case "Connecticut":    return "CT";
    case "Delaware":       return "DE";
    case "Florida":        return "FL";
    case "Georgia":        return "GA";
    case "Hawaii":         return "HI";
    case "Idaho":          return "ID";
    case "Illinois":       return "IL";
    case "Indiana":        return "IN";
    case "Iowa":           return "IA";
    case "Kansas":         return "KS";
    case "Kentucky":       return "KY";
    case "Louisiana":      return "LA";
    case "Maine":          return "ME";
    case "Maryland":       return "MD";
    case "Massachusetts":  return "MA";
    case "Michigan":       return "MI";
    case "Minnesota":      return "MN";
    case "Mississippi":    return "MS";
    case "Missouri":       return "MO";
    case "Montana":        return "MT";
    case "Nebraska":       return "NE";
    case "Nevada":         return "NV";
    case "New Hampshire":  return "NH";
    case "New Jersey":     return "NJ";
    case "New Mexico":     return "NM";
    case "New York":       return "NY";
    case "North Carolina": return "NC";
    case "North Dakota":   return "ND";
    case "Ohio":           return "OH";
    case "Oklahoma":       return "OK";
    case "Oregon":         return "OR";
    case "Pennsylvania":   return "PA";
    case "Rhode Island":   return "RI";
    case "South Carolina": return "SC";
    case "South Dakota":   return "SD";
    case "Tennessee":      return "TN";
    case "Texas":          return "TX";
    case "Utah":           return "UT";
    case "Vermont":        return "VT";
    case "Virginia":       return "VA";
    case "Washington":     return "WA";
    case "D.C.":           return "DC";
    case "West Virginia":  return "WV";
    case "Wisconsin":      return "WI";
    case "Wyoming":        return "WY";
  }

  return state;
}

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

function MapItAddress(str) { this._init(str); }

////////////////////////////////////////////////////////////////////////////////

MapItAddress.prototype = {
  _raw:null,

  valid:null,
  settings:null,

  street:null,
  city:null,
  state:null,
  zip:null,
  country:null,

_console:null,

////////////////////////////////////////////////////////////////////////////////

  validate:function() {
    this.valid = true;
  },

////////////////////////////////////////////////////////////////////////////////

  _init:function(str) {
    this._console = Components.classes["@mozilla.org/consoleservice;1"]
                    .getService(Components.interfaces.nsIConsoleService);

    this.settings = new MapItSettings();
    this._parse(str);

    // TODO :jah: make this work for other countries
    this.country = "US";
  },

////////////////////////////////////////////////////////////////////////////////

  _parse:function(str) {
    this._raw = str;
    this.valid = false;

    if (str) {
      // try to match the address to an existing regular expression
      var regexps = this.settings.regexps;
      for (var idx = 0; idx < regexps.length; idx++) {
        var match = (new RegExp(regexps[idx])).exec(this._raw, "m");
        if (match != null) {
          this.street = match[1];
          this.city = match[2];
          this.state = match[3];
          this.zip = match[4];
          this.valid = true;
          break;
        }
      }
    }
  },

////////////////////////////////////////////////////////////////////////////////

  toString:function() {
    return this.street + "\n"
           + this.city + ", " + this.state + " " + this.zip + "\n"
           + this.country;
  },

////////////////////////////////////////////////////////////////////////////////
};
